var UrlFilter=require("filter/rules/url-filter.js").UrlFilter,CssFilter=require("filter/rules/css-filter.js").CssFilter,CssFilterRule=require("filter/rules/css-filter-rule.js").CssFilterRule,ScriptFilter=require("filter/rules/script-filter.js").ScriptFilter,ScriptFilterRule=require("filter/rules/script-filter-rule.js").ScriptFilterRule,UrlFilterRule=require("filter/rules/url-filter-rule.js").UrlFilterRule,SafebrowsingFilter=require("filter/safebrowsing-filter.js").SafebrowsingFilter,Log=require("utils/log.js").Log,
UrlUtils=require("utils/url.js").UrlUtils,StringUtils=require("utils/common.js").StringUtils,IpResolver=require("utils/ip-resolver.js").IpResolver,Prefs=require("ext/prefs.js").Prefs,Uri=require("utils/uri.js").Uri,userSettings=require("utils/user-settings.js").userSettings,RequestFilter=exports.RequestFilter=function(){this.urlBlockingFilter=new UrlFilter;this.urlWhiteFilter=new UrlFilter;this.cssFilter=new CssFilter;this.scriptFilter=new ScriptFilter;this.safebrowsingFilter=new SafebrowsingFilter;
this.requestCache={__proto__:null};this.requestCacheSize=0};
RequestFilter.prototype={requestCacheMaxSize:1E3,addRulesByFilterId:function(a,b){if(b)for(var c=0;c<b.length;c++)this.addRuleByFilterId(a,b[c])},addRuleByFilterId:function(a,b){null==b||!b.ruleText?Log.error("FilterRule must not be null"):(b.filterId=a-0,b instanceof UrlFilterRule?b.whiteListRule?this.urlWhiteFilter.addRule(b):this.urlBlockingFilter.addRule(b):b instanceof CssFilterRule?this.cssFilter.addRule(b):b instanceof ScriptFilterRule&&this.scriptFilter.addRule(b),this._clearCache())},removeRulesByFilterId:function(a){this.urlWhiteFilter.removeRulesByFilterId(a);
this.urlBlockingFilter.removeRulesByFilterId(a);this.cssFilter.removeRulesByFilterId(a);this.scriptFilter.removeRulesByFilterId(a);this._clearCache()},removeRule:function(a){if(null==a)throw"FilterRule must not be null";a instanceof UrlFilterRule?a.whiteListRule?this.urlWhiteFilter.removeRule(a):this.urlBlockingFilter.removeRule(a):a instanceof CssFilterRule?this.cssFilter.removeRule(a):a instanceof ScriptFilterRule&&this.scriptFilter.removeRule(a);this._clearCache()},getSelectorsForUrl:function(a){a=
UrlUtils.toPunyCode(UrlUtils.getDomainName(a));return userSettings.collectHitsCount()?this.cssFilter.buildCssHits(a,Prefs.appId):this.cssFilter.buildCss(a)},getInjectedSelectorsForUrl:function(a){return this.cssFilter.buildInjectCss(UrlUtils.toPunyCode(UrlUtils.getDomainName(a)))},getCssForStyleSheet:function(){return this.cssFilter.buildCssForStyleSheet()},getScriptsForUrl:function(a){return this.scriptFilter.buildScript(UrlUtils.toPunyCode(UrlUtils.getDomainName(a)))},getUserScriptsForUrl:function(a,
b){return this.scriptFilter.buildScriptFromUserRules(UrlUtils.toPunyCode(UrlUtils.getDomainName(a)),b)},clearRules:function(){this.urlWhiteFilter.clearRules();this.urlBlockingFilter.clearRules();this.cssFilter.clearRules()},findWhiteListRule:function(a,b,c){return this._checkWhiteList(a,b,c)},getWhiteListRules:function(a){return null==this.urlWhiteFilter||StringUtils.isEmpty(a)?null:this.urlWhiteFilter.getFilteredRules(a,a,"DOCUMENT")},findRuleForRequest:function(a,b,c){Log.debug("Checking request filter for {0} - {1}",
a,b);var d=a+" "+b+" "+c;if(d in this.requestCache)return this.requestCache[d];a=this._filterHttpRequest(a,b,c);this.requestCacheSize>this.requestCacheMaxSize&&this._clearCache();this.requestCache[d]=a;this.requestCacheSize++;return a},addToSafebrowsingTrusted:function(a){this.safebrowsingFilter.addToSafebrowsingTrusted(a)},checkSafebrowsingFilter:function(a,b){if(userSettings.getSafebrowsingInfo().enabled){Log.debug("Checking safebrowsing filter for {0}",a);var c=function(c){c?(Log.debug("Following safebrowsing filter has been fired: {0}",
c),b(this.safebrowsingFilter.getErrorPageURL(a,c))):Log.debug("No safebrowsing rule found, exiting")}.bind(this);this.safebrowsingFilter.lookupUrlWithCallback(a,c)}},_checkWhiteList:function(a,b,c){return null==this.urlWhiteFilter||StringUtils.isEmpty(a)?null:this.urlWhiteFilter.isFiltered(a,b,c)},_checkUrlBlockingList:function(a,b,c){return null==this.urlBlockingFilter||StringUtils.isEmpty(a)?null:this.urlBlockingFilter.isFiltered(a,b,c)},_filterHttpRequest:function(a,b,c){Log.debug("Filtering http request: url={0} referrer={1}",
a,b);a=this._innerFilterHttpRequest(a,b,c)||this._filterIpAddresses(a,b,c);Log.debug("Finished filtering http request. Rule found: {0}",null==a?"no":a.ruleText);return a},_innerFilterHttpRequest:function(a,b,c){var d=this._checkWhiteList(a,b,c);if(null!=d)return Log.debug("White list rule found {0} for {1} referrer: {2}",d.ruleText,a,b),d;d=this._checkWhiteList(b,b,"URLBLOCK");if(null!=d)return Log.debug("Referrer white list rule found: {0} for {1}",d.ruleText,b),d;c=this._checkUrlBlockingList(a,
b,c);null!=c&&Log.debug("Black list rule found: {0} for {1} referrer: {2}",c.ruleText,a,b);return c},_filterIpAddresses:function(a,b,c){Log.debug("Start filtering ip address: url={0}, referrer={1}",a,b);a=this._resolveHostToIp(a);Log.debug("Replaced host to ip: url={0}, referrer={1}",a,b);return this._innerFilterHttpRequest(a,b,c)},_resolveHostToIp:function(a){if(StringUtils.isEmpty(a)||StringUtils.startWith(a,"https://"))return null;var b=UrlUtils.getHost(a),b=IpResolver.resolveIp(b);if(!b)return null;
try{var c=new Uri(a);c.setHost(b);c.port()||c.setPort(80);return c.toString()}catch(d){return Log.error("Error create URI from {0} cause {1}",a,d),null}},_clearCache:function(){if(0<this.requestCacheSize)this.requestCache={__proto__:null},this.requestCacheSize=0}};